#include once "rendering.bi"

' test of:
' SimulatorCreateRigidBodyWorldJoint
' JointSetPositionRotationFrameWorld
' JointEnable
' gfx.Render(joint)

var sim = CreateSimulator()

var ground = CreateAnimatedBodyBox(sim,50,1,50)
AnimatedBodySetPosition(ground,0,-.5,0)

var box = CreateRigidBodyCube(sim,1,10)
RigidBodySetPosition(box,8,10,0)

var joint = SimulatorCreateRigidBodyWorldJoint(sim,box)
JointSetType(joint,NE_JOINT_BALLSOCKET)
JointSetPositionRotationFrameWorld(joint, 0,10,0, 0,0,0)
JointSetDampingFactor(joint,sqr(RigidbodyGetMass(box)))
JointEnable(joint,true)


dim as RENDERER gfx = RENDERER(640,480)
dim as integer frame
while inkey()=""
  SimulatorAdvance(sim) ' 60 Hz.
  if frame mod 2=0 then ' 30 Hz.
    gfx.cls
    glLoadIdentity()
    glTransLatef (0,-4,-15) 
    gfx.Render(ground)
    gfx.Render(box)
    gfx.Render(joint)
    gfx.SwapBuffers()
  else
    sleep(10) ' don't use all CPU cycles
  end if
  frame+=1
wend

DestroySimulator(sim)

