#include once "rendering.bi"

' test of:
' SimulatorCreateRigidBodyAnimatedBodyJoint

var sim = CreateSimulator()

var ground = CreateAnimatedBodyBox(sim,20,.2,20)
AnimatedBodySetPosition(ground,0,-.1,0)

' create a nail (fixed in space)
var nail = CreateAnimatedBodySphere(sim,.25)
AnimatedBodySetPosition(nail, 0,10,0)

' create a box
var box = CreateRigidBodyCube(sim,2,100)
RigidBodySetPosition(box,8,10,0)

' connect box with the nail via joint
var joint = SimulatorCreateRigidBodyAnimatedBodyJoint(sim,box,nail)
JointSetType(joint,NE_JOINT_BALLSOCKET)
JointSetPositionRotationV3FrameWorld(joint, AnimatedBodyGetPositionV3(nail), neV3(0,0,0))
JointSetDampingFactor(joint,sqr(RigidbodyGetMass(box)))

JointEnable(joint,true)

dim as RENDERER gfx = RENDERER(640,480)
dim as integer frame
while inkey()=""
  SimulatorAdvance(sim) ' 60 Hz.
  if frame mod 2=0 then ' 30 Hz.
    var p = RigidBodyGetPositionV3(box)
    gfx.cls
    glLoadIdentity()
    LookAt(0,5,20, p.x,p.y*0.5,p.z, 0,1,0) 
    gfx.Render(ground)
    gfx.Render(nail)
    gfx.Render(box)
    gfx.Render(joint)
    gfx.SwapBuffers()
  else
    sleep(10) ' don't use all CPU cycles
  end if
  frame+=1
wend

DestroySimulator(sim)

