#include once "rendering.bi"

' a chain of rigidbodies

const MAX_BODIES = 30
dim as neRigidBody ptr bodies(MAX_BODIES-1)

var sim = CreateSimulator()

var ground = CreateAnimatedBodyBox(sim,200,2,200)
AnimatedBodySetPosition(ground,0,-1,0)

dim as neJoint ptr joint
for i as integer = 0 to MAX_BODIES-1
  bodies(i) = CreateRigidBodySphere(sim,1,10)
  RigidBodySetPosition(bodies(i),i,MAX_BODIES,0)
  if i=0 then
    joint = SimulatorCreateRigidBodyWorldJoint(sim,bodies(i))
  else  
    joint = SimulatorCreateRigidBodyRigidBodyJoint(sim,bodies(i),bodies(i-1))
  end if  
  JointSetType(joint,NE_JOINT_BALLSOCKET)
  JointSetPositionRotationFrameWorld(joint, i,MAX_BODIES,0, 0,0,0)
  JointEnable(joint,true)
next

for i as integer = 0 to MAX_BODIES-1
  RigidBodySetCollideDirectlyConnected(bodies(i),false)
next

dim as RENDERER gfx = RENDERER(640,480)
dim as integer frame
while inkey()=""
  SimulatorAdvance(sim) ' 60 Hz.
  if frame mod 2=0 then ' 30 Hz.
    var p = RigidBodyGetPositionV3(bodies(MAX_BODIES-1))
    gfx.cls
    glLoadIdentity()
    LookAt(0,MAX_BODIES\2,MAX_BODIES*1.25, 0,MAX_BODIES\2,0, 0,1,0) 
    gfx.Render(ground)
    for i as integer =0 to MAX_BODIES-1
      gfx.Render(bodies(i))
    next  
    gfx.SwapBuffers()
  else
    sleep(10) ' don't use all CPU cycles
  end if
  frame+=1
wend

DestroySimulator(sim)

