#include once "rendering.bi"

' stress test of stacking boxes 
const MAX_CUBES   = 25*25
dim as neSimulatorSizeInfo SizeInfo
with SizeInfo
  .rigidBodiesCount     = MAX_CUBES + 1 ' one sphere
  .animatedBodiesCount  = 1
  .geometriesCount      = .rigidBodiesCount + .animatedBodiesCount
  .overlappedPairsCount = (.geometriesCount*(.geometriesCount-1))/2
end with
var sim = CreateSimulator(SizeInfo)

var grd = CreateAnimatedBodyBox(sim,1000,2,1000)
AnimatedBodySetPosition(grd,0,-2,0)

const as integer SQR_CUBES = sqr(MAX_CUBES)
dim as neRigidBody ptr cubes(MAX_CUBES-1)
for i as integer = 0 to MAX_CUBES-1
  cubes(i) = CreateRigidBodyCube(sim,1,1)
  var col = i  \  SQR_CUBES
  var row = i mod SQR_CUBES
  RigidBodySetPosition(cubes(i),(-SQR_CUBES\2) + col + (row and 1)*0.5,-.5+row*1.01,50)
  RigidbodySetLinearDamping (cubes(i),.5)
  RigidbodySetAngularDamping(cubes(i),.5)
next

dim as RENDERER gfx=RENDERER(640,480)
LookAt(0,10,-2, 0,10,0, 0,1,0)

var n=0
var flag=true
while flag=true
  n=0 : flag=false
  for i as integer = 1 to 30
    SimulatorAdvance(sim)
  next 
  gfx.cls
  gfx.render(grd)
  for i as integer = 0 to MAX_CUBES-1
    if RigidBodyIsIdle(cubes(i))=false then n+=1:flag=true
    gfx.render(cubes(i))
  next
  gfx.Swapbuffers
  windowtitle "build a wall of stacking bricks please wait until all bricks becomes resting ! ... " & n
wend
for i as integer = 0 to MAX_CUBES-1
  RigidbodySetLinearDamping (cubes(i),0.01)
  RigidbodySetAngularDamping(cubes(i),0.01)
next

var sphere = CreateRigidBodySphere(sim,1,1000)
RigidBodySetPosition(sphere,0,SQR_CUBES\4,60)

dim as neV3 spherepos,heightpos,boxpos
dim as integer frame
windowtitle "OK"
while inkey()=""
  SimulatorAdvance(sim,1/100)
  if frame mod 3=0 then
    gfx.cls
    gfx.render(grd)
    gfx.render(sphere)
    heightpos.y=0
    for i as integer = 0 to MAX_CUBES-1
      if RigidBodyIsIdle(cubes(i)) then
        boxpos=RigidBodyGetPositionV3(cubes(i))
        if boxpos.y>heightpos.y then heightpos=boxpos
      end if
      gfx.Render(cubes(i))
    next 
    gfx.SwapBuffers()
  else  
    sleep(10)
  end if
 
  spherepos = RigidBodyGetPositionV3(sphere)
  if spherepos.z>55 then
    for i as integer = 0 to MAX_CUBES-1
      if RigidBodyIsIdle(cubes(i)) then
        boxpos=RigidBodyGetPositionV3(cubes(i))
        if boxpos.y>heightpos.y then heightpos=boxpos
      end if
    next 
    spherepos.x=0 : spherepos.y=heightpos.y/2 :  spherepos.z=0
    heightpos-=spherepos
    heightpos.x+=(rnd-rnd)*0.1:heightpos.y+=(rnd-rnd)*0.1
    heightpos.normalize : heightpos*=60
    RigidBodySetPosition(sphere,0,spherepos.y+4,0)
    RigidBodySetVelocity(sphere,heightpos)
  end if 

  
  frame+=1
wend
DestroySimulator(sim)