#include once "rendering.bi"

' test of:
'  CreateRigidBodySphere
'  CreateRigidBodyCapsule

const NBODIES = 500
dim as neSimulatorSizeInfo SizeInfo
with SizeInfo
  .rigidBodiesCount     = NBODIES
  .animatedBodiesCount  = 1
  .geometriesCount      = .rigidBodiesCount + .animatedBodiesCount
  .overlappedPairsCount = .geometriesCount*4
end with  

var sim = CreateSimulator(SizeInfo)

var gound = CreateAnimatedBodyBox(sim,1000,20,1000)
AnimatedBodySetPosition(gound,0,-10,0)


dim as neRigidBody ptr bodies(NBODIES-1)
for i as integer = 0 to NBODIES-1
  select case i and 3
  case 0 : bodies(i) = CreateRigidBodyCube   (sim,1+rnd,100)
  case 1 : bodies(i) = CreateRigidBodySphere (sim,1+rnd,100)
  case 2 : bodies(i) = CreateRigidBodyBox    (sim,1+rnd,1+rnd,1+rnd,100)
  case 3 : bodies(i) = CreateRigidBodyCapsule(sim,1+rnd,1+rnd,100)
  end select
  RigidBodySetPosition(bodies(i),(rnd-rnd)*50,10+rnd*100,(rnd-rnd)*50)
next  

dim as integer frame
dim as RENDERER gfx
while inkey()="" 
  SimulatorAdvance(sim) ' 60 Hz.
  if frame mod 2=0 then ' 30 Hz.
    gfx.cls
      glLoadIdentity()
      glTransLatef(0,-15,-200) ' move the camera
      gfx.render(gound)
      for i as integer = 0 to NBODIES-1
        select case i and 3
        case 0 : gfx.render(bodies(i),.8,.8,.2)
        case 1 : gfx.render(bodies(i),.2,.8,.2)
        case 2 : gfx.render(bodies(i),.8,.2,.2)
        case 3 : gfx.render(bodies(i),.2,.8,.8)
        end select
      next  
    gfx.Swapbuffers
  else
    sleep 10 ' don't use all CPU cycles
  end if
  frame+=1
wend

DestroySimulator(sim)


