#include once "rendering.bi"

' test of:
' neSensor and RigidBodyAddController

sub ControllerCB cdecl (byval rbc as neRigidBodyController ptr, _
                        byval dt  as single)
  var rb = RigidBodyControllerGetRigidBody(rbc)
  RigidBodyBeginIterateSensor(rb)
  var sen = RigidBodyGetNextSensor(rb)
  while sen
    var depth = SensorGetDetectDepth(sen)
    if depth>0 then
      var p = SensorGetLinePositionV3(sen)
      RigidBodyApplyImpulse(rb,neV3(p.x,depth*400*dt,p.z))
    end if 
    sen = RigidBodyGetNextSensor(rb)
  wend  
end sub

'
' main
'
var sim = CreateSimulator()
var ground = CreateAnimatedBodyBox(sim,1000,2,1000)
AnimatedBodySetPosition(ground,0,-2,0)

var box = CreateRigidBodyCube(sim,5,100)
var sen = RigidBodyAddSensor(box)
SensorSetLineSensor(sen, 0,-2.5, 0, 0,-6,0)
RigidBodyUpdateBoundingInfo(box)

RigidBodySetPositionRotation(box,0,10,0, 0,45,0)
RigidBodySetAngularDamping(box,.5) ' damp the rotation

var controller = RigidBodyAddController(box, @ControllerCB)

dim as RENDERER gfx
dim as integer frame
while inkey()=""
  SimulatorAdvance(sim) ' = 60 Hz
  if frame mod 2=0 then ' = 30 Hz
    var p = RigidBodyGetPositionV3(box)
    gfx.cls
    glLoadIdentity()
    LookAt(0,2,30, p.x,p.y,p.z, 0,1,0)
    gfx.Render(ground)
    gfx.Render(box,true) ' true = draw sensors also
    gfx.SwapBuffers()
  else
    sleep(10) ' don't use all CPU cycles
  end if
  frame+=1
wend

DestroySimulator(sim)

